package es.caib.signatura.web;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class DownloadServlet extends HttpServlet{
	protected final String DOWNLOAD_FOLDER="/app/caib/signaturacaib/downloads/";
	protected final String DATE_ONE = (new SimpleDateFormat( "EEE, dd MMM yyyy HH:mm:ss zzz", Locale.US)).format(new Date(1));
	
	protected void service(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		//PJR - FACTOR DE SEGURIDAD - sólo descargar fichero, no ruta que permita acceder a otros directorios del disco
		String filename=req.getPathInfo().substring(req.getPathInfo().lastIndexOf('/')+1);
		
		if("".equals(filename)){
			resp.setStatus(HttpServletResponse.SC_NOT_FOUND);
			return;
		}
		
		File file=new File(DOWNLOAD_FOLDER,filename);
		if(file.exists()){
			//PJR 20100201-1 inici de las modificaciones para evitar el bug de descarga de documentos por SSL sobre explorer 6
			//http://community.jboss.org/wiki/DisableCacheControl
			
			resp.reset();
			resp.addHeader("Expires", DATE_ONE);
			resp.setDateHeader("Last-Modified",new Date().getTime());
			
			//PFR 20100201-1 fin
			
			
			//.bin application/octet-stream extension if requested file does not have
			String extension=(filename.lastIndexOf('.')!=-1)?filename.substring(filename.lastIndexOf('.')):".bin";
			String mimetype=new ContentTypeRegistry().getContentTypeByExtension(extension);
			resp.setContentType(mimetype);
			resp.setContentLength((int)file.length());
			resp.addHeader("content-disposition", "inline; filename=" + filename);

			IOUtils.appendStream(resp.getOutputStream(), new FileInputStream(file));

			
		}else{
			resp.setStatus(HttpServletResponse.SC_NOT_FOUND);
		}
		
	}

}
