/*
 * Created on 02/09/2005
 *
 */
package es.caib.signatura.client.applet;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Font;
import java.awt.HeadlessException;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Properties;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;

import es.caib.signatura.api.Signature;
import es.caib.signatura.api.SignatureCertNotFoundException;
import es.caib.signatura.api.SignaturePrivKeyException;
import es.caib.signatura.api.SignatureProviderException;
import es.caib.signatura.api.SignatureSignException;
import es.caib.signatura.api.SignatureVerifyException;
import es.caib.signatura.api.Signer;
import es.caib.signatura.api.SignerFactory;
import es.caib.signatura.api.UpgradeNeededException;


/**
 * @author u07286
 *
 */
public class MassiveSMIMESignApplet extends Applet {
	public static final int WIDTH=700;
	public static final int HEIGHT=300;
	
	private String contentType;
	boolean timeStamp;
	private JPanel panelCenter = new JPanel();
	private BorderLayout layoutMain = new BorderLayout();
	private JList list = new JList();
	private JScrollPane scrollPanel = new JScrollPane(list);
	private JTextField passwordText = new JPasswordField();
	private JLabel passwordLabel = new JLabel();
	private JButton signarBtn = new JButton();
	private JLabel jLabel1 = new JLabel();
	private JLabel jLabel2 = new JLabel();
	private JLabel jLabel3 = new JLabel();
	private PropertyResourceBundle signaturaProperties;
	private es.caib.signatura.api.Signer signer = null;
	
	//Applet params
	private String [] sources;
	private String [] targets;
	private URLConnection sourceConnection;
	private String motivoFirma="";
	private int signaturePosition=Signer.PDF_SIGN_POSITION_NONE;
	private String jump=null;
	/**
	 * @throws java.awt.HeadlessException
	 */
	public MassiveSMIMESignApplet() throws HeadlessException {
	}
	
	/** Leemos los parámetros de configuración establecidos en el tag HTTP
	 */
	public void start() {
		super.start();
		String source = this.getParameter("source");
		String target = this.getParameter("target");
		sources=source.split("[|]");
		targets=target.split("[|]");
		contentType = this.getParameter("contentType");
		motivoFirma= "He aprobado el documento";
		signaturePosition= Signer.PDF_SIGN_POSITION_NONE;
		jump=getParameter("jump");
		
		try {
			jbInit();
		} catch (Exception e2) {
			JOptionPane.showMessageDialog(null, e2.toString(), "Firma electrònica", JOptionPane.ERROR_MESSAGE);
			SigDebug.error(e2);
		}		
		
	}
	

	
	public void init ()
	{
		try
		{
			signaturaProperties =  (PropertyResourceBundle) ResourceBundle.getBundle("signatura");
		}
		catch(Exception e)
		{
			SigDebug.error(e);
		}
		
	}
	
	private void jbInit() throws Exception
	{
		setLayout(layoutMain);
		panelCenter.setLayout(null);
		
		scrollPanel.setBounds(new Rectangle(20, 25, 450, 120));
		passwordText.setBounds(new Rectangle(20, 170, 135, 20));
		passwordLabel.setText(signaturaProperties.getString ("insertPassword"));
		passwordLabel.setBounds(new Rectangle(20, 150, 195, 15));
		passwordText.addKeyListener( new KeyAdapter ()
			{
				public void keyPressed(KeyEvent e) {
					if (e.getKeyCode() == KeyEvent.VK_ENTER)
						signarBtn_mouseClicked();
				}
			}
		);
		signarBtn.setText(signaturaProperties.getString("sign"));
		signarBtn.setBounds(new Rectangle(160, 168, 85, 25));
		signarBtn.setFont(new Font("Arial", 1, 14));
		signarBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				signarBtn_mouseClicked();
			}
		});
		
		jLabel3.setText(signaturaProperties.getString("selectCert"));
		jLabel3.setBounds(new Rectangle(20, 5, 350, 20));
		add(panelCenter, BorderLayout.CENTER);
		panelCenter.add(jLabel3, null);
		panelCenter.add(jLabel2, null);
		panelCenter.add(jLabel1, null);
		panelCenter.add(signarBtn, null);
		panelCenter.add(passwordLabel, null);
		panelCenter.add(passwordText, null);
		scrollPanel.getViewport().add(list, null);
		panelCenter.add(scrollPanel, null);

		initSignature();
		
	}
	
	private void initSignature()
	{
		String[] certList = {signaturaProperties.getString("gettingCertList")};
		list.setListData(certList);
		
		//recuperamos la configuración del sistema de firma
		String signaturaPropertiesServletURL=getParameter("signaturaPropertiesServletURL");
		SignerFactory sf=null;
		try {	
			if(signaturaPropertiesServletURL!=null){			
				Properties p=new Properties();
				p.load(new URL(signaturaPropertiesServletURL).openStream());
				sf = new SignerFactory(p);

			}else{
				//En la CAIB nos conviene mejor esto
				sf = new SignerFactory();
			}
		

			signer = sf.getSigner();		
		} catch (UpgradeNeededException e) {
			SigDebug.error(e);
			showMessageError ("upgradeneeded");

			URL newUrl = e.getUrl();
			if (newUrl != null && !newUrl.equals("")) {
				// SigDebug.info( "Url orig: " + newUrl );
				try
				{
					//newUrl = Install.getHtmlInstallUrl( newUrl );
					newUrl = new URL(newUrl.toExternalForm().replaceAll("install\\.jnlp",
						"install.jsp"));
				}
				catch( Exception e2 ) 
				{
				}
				// SigDebug.info( "Url canviada: " + newUrl );
				this.getAppletContext().showDocument( newUrl );
			}
			return;
		} catch (MalformedURLException e) {
			SigDebug.error(e);
			showMessageError("Error en la configuración de la firma: "+e.getMessage());
			return;
		} catch (IOException e) {
			SigDebug.error(e);
			showMessageError("Error en la configuración de la firma: "+e.getMessage());
			return;
		}		

		if (signer == null)
		{
			showMessageError("NoProvider");
			return;
		}

		signarBtn.setEnabled(false);
		
		
		try {
			certList = signer.getCertList(contentType);
		}
		catch (SignaturePrivKeyException ex)
		{
			showMessageError("certListNotFound");
			SigDebug.error(ex); 
			return;
		}
		catch (SignatureCertNotFoundException cex)
		{
			showMessageError("certListNotFound");
			SigDebug.error(cex); 
			return;
		}
		
		if (certList!=null){
			list.setListData(certList);
			if (certList.length == 1)
			{
				list.setSelectedIndex(0);
				passwordText.requestFocus();
			}
			else
			{
				list.requestFocus();
			}
		}
		
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		signarBtn.setEnabled(true);
		
	}
	
	
	
	
	
	private void signarBtn_mouseClicked()
	{
		
		URL sourceURL;
		String certName =null;
		
		//por cada documento de entrada
		//firmamos
		//enviamos el contenido al servlet de recepción
		//verificamos la respuesta del servlet de recepción
		
		for(int i=0;i<sources.length;i++){
			try {
				
				sourceURL = new URL (sources[i]);
				sourceConnection = sourceURL.openConnection();
	
				sourceConnection.connect();
				//contentType = sourceConnection.getContentType();
	
				if (!signarBtn.isEnabled())
				{
					return;
				}
				
				certName = (String)list.getSelectedValue();
				
				if (certName==null)
				{
					showMessageBox("selectCert");
					return;
				}
	
			} catch (MalformedURLException e) {
				JOptionPane.showMessageDialog(null, "URL incorrecta "+sources[i], "Firma electrònica", JOptionPane.ERROR_MESSAGE);
				return ;
	
			} catch (IOException e1) {
				JOptionPane.showMessageDialog(null, "URL inaccesible "+sources[i], "Firma electrònica", JOptionPane.ERROR_MESSAGE);
				return ;
			} catch (Exception e2) {
				JOptionPane.showMessageDialog(null, e2.toString(), "Firma electrònica", JOptionPane.ERROR_MESSAGE);
				SigDebug.error(e2);
			}
			
			
			setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			
			Signature signatureData = null;
			ByteArrayOutputStream o_content=new ByteArrayOutputStream();
			InputStream in=null;
			ByteArrayInputStream i_content=null;
			
			try{
				
				in=sourceConnection.getInputStream();
				IOUtils.streamAppendCopy(o_content, in,10240);
				i_content=new ByteArrayInputStream(o_content.toByteArray());
				
				signatureData = signer.sign(i_content,
						certName, 
						passwordText.getText(), 
						contentType);
			}
			catch (FileNotFoundException fe)
			{
				showMessageError("documentFileNotFound");
				return;
			}
			catch (IOException io)
			{
				showMessageError("networkError");
				return;
			}
			catch (SignatureSignException e1)
			{
				JOptionPane.showMessageDialog(null, e1.getMessage(), 
						"Govern Balear: Signatura Digital", JOptionPane.ERROR_MESSAGE);
				return;
			}
			catch (Throwable se)
			{
				SigDebug.error(se);
				Throwable root = se;
				while (root.getCause() != null)
					root = root.getCause();
				String message = signaturaProperties.getString("signatureError");
				if (root.getMessage() != null)
					message = message+" "+root.getMessage();
				else
					message = message+" ["+root.getClass().getName()+"]";
				JOptionPane.showMessageDialog(null, message, 
						"Govern Balear: Signatura Digital", JOptionPane.ERROR_MESSAGE);
				return;
			} finally {
				setCursor(Cursor.getDefaultCursor());
				if(i_content!=null){
					try{
						i_content.close();
						i_content=null;
					}catch(Exception e){}
				}
			}
			
			
			try{
				// Generar la firma
				HttpURLConnection c = (HttpURLConnection) new URL(targets[i]).openConnection();
				c.setDoInput(true);
				c.setDoOutput(true);
				c.setRequestMethod("POST");
				c.connect();
				OutputStream o = c.getOutputStream();
				i_content=new ByteArrayInputStream(o_content.toByteArray());
				signer.generateSMIME(i_content, signatureData, o);
				o.close();
				
				if (signer.verify(sourceConnection.getURL(),signatureData)){
					SigDebug.info("La verificacion de la firma es correcta");
				}
				try {
					SigDebug.info(signatureData.getDate().toLocaleString());
					SigDebug.info(signatureData.getParsedCertificate().getName());
				} catch (Exception e) {
					SigDebug.info("No hay sello de tiempo");
				}
				SigDebug.info ("Result = "+c.getResponseMessage());
				if (c.getResponseCode() != 200)
				{
					throw new IOException ("Error enviando fichero");
				}
			}
			catch (FileNotFoundException fe)
			{
				SigDebug.error(fe);
				showMessageError("signatureFileSaveError");
				return;
			}
			catch (IOException io)
			{
				SigDebug.error(io);
				showMessageError("signatureFileSaveError");
				return;
			} catch (SignatureProviderException e) {
				SigDebug.error(e);
			} catch (SignatureVerifyException e) {
				SigDebug.error(e);
			}
		}
		
		if (jump != null)
		{
			try {
				getAppletContext().showDocument(new URL(jump));
				return;
			} catch (MalformedURLException e) {
				SigDebug.error(e);
			}
		}
		else
			showMessageBox("signatureOK");
	}
	
	
	private void showMessageBox(String message)
	{
		JOptionPane.showMessageDialog(null, signaturaProperties.getString(message), "Govern Balear: Signatura Digital", JOptionPane.INFORMATION_MESSAGE);
	}
	
	private void showMessageError(String message)
	{
		JOptionPane.showMessageDialog(null, signaturaProperties.getString(message), "Govern Balear: Signatura Digital", JOptionPane.ERROR_MESSAGE);
	}
	
	
}
