package es.caib.signatura.client.applet;

import java.awt.Cursor;
import java.awt.Font;
import java.awt.HeadlessException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.JApplet;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

import es.caib.signatura.api.Signer;
import es.caib.signatura.api.SignerFactory;
import es.caib.signatura.api.UpgradeNeededException;
import es.caib.signatura.impl.util.SigDebug;

public class VerifyApplet extends JApplet {

	
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel = null;
	private JLabel jMaquina = null;
	private JLabel jLibreria = null;
	private String ua;
	private String browser;
	private String browserBuild;
	private float browserVer;
	private JLabel jLabel2 = null;
	private JLabel jBrowser = null;
	private boolean jvmActualitzada = false;
	private boolean lt = false;
	private JLabel jLabel3 = null;
	private JLabel jLabel5 = null;
	private JLabel jLabel6 = null;
	private JLabel jLabel7 = null;
	private JLabel jMaquinaDesc = null;
	private JLabel jLibDesc = null;
	private String dir = null; 
	private ResourceBundle res = null;
	private String lng = null;
	private String installURL;
	public VerifyApplet() throws HeadlessException {
		super();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	public void init() {
		this.setBounds(new java.awt.Rectangle(0,0,640,120));
		this.dir = this.getParameter("url");
		this.lng = this.getParameter("lng");
		Locale locale = null;
		if (lng==null) { lng="es";}
		if (lng.equals("es")){
			locale=new Locale("es","ES");
		}
		if (lng.equals("ca")) {
			locale=new Locale("ca","CA");
		}
	    res = ResourceBundle.getBundle("message", locale);
	    this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLibDesc = new JLabel();
			jLibDesc.setBounds(new java.awt.Rectangle(436,60,94,17));
			jLibDesc.setForeground(new java.awt.Color(220,0,232));
			jLibDesc.setHorizontalAlignment(SwingConstants.LEFT);
			jLibDesc.setHorizontalTextPosition(SwingConstants.LEFT);
			jLibDesc.setText(res.getString("descargar"));
			jLibDesc.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			jLibDesc.addMouseListener(new java.awt.event.MouseAdapter() {   
				public void mouseExited(java.awt.event.MouseEvent e) {    
					jLibDesc.setText("<html><body>"+res.getString("descargar")+"</body></html>");
					setCursor( new Cursor( Cursor.DEFAULT_CURSOR ) );
				}   
				public void mouseEntered(java.awt.event.MouseEvent e) {    
					jLibDesc.setText("<html><body><u>"+res.getString("descargar")+"</u></body></html>");
					setCursor( new Cursor( Cursor.HAND_CURSOR ) );
				}
				public void mouseClicked(java.awt.event.MouseEvent e) {
					try {
						//getAppletContext().showDocument(new URL(installURL+"?jvm="+System.getProperty("java.home")),"_blank");
						getAppletContext().showDocument(new URL(installURL));
					} catch (MalformedURLException e1) {
						SigDebug.error(e1);
					}
				}
			});
			jMaquinaDesc = new JLabel();
			jMaquinaDesc.setBounds(new java.awt.Rectangle(336,39,93,17));
			jMaquinaDesc.setHorizontalAlignment(SwingConstants.LEFT);
			jMaquinaDesc.setHorizontalTextPosition(SwingConstants.LEFT);
			jMaquinaDesc.setText(res.getString("descargar"));
			jMaquinaDesc.setForeground(new java.awt.Color(220,0,232));
			jMaquinaDesc.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			jMaquinaDesc.addMouseListener(new java.awt.event.MouseAdapter() {   
				public void mouseExited(java.awt.event.MouseEvent e) {    
					jMaquinaDesc.setText("<html><body>"+res.getString("descargar")+"</body></html>");
					setCursor( new Cursor( Cursor.DEFAULT_CURSOR ) );
				}   
				public void mouseEntered(java.awt.event.MouseEvent e) {    
					jMaquinaDesc.setText("<html><body><u>"+res.getString("descargar")+"</u></body></html>");
					setCursor( new Cursor( Cursor.HAND_CURSOR));
				}   
			
				public void mouseClicked(java.awt.event.MouseEvent e) {
					try {
						getAppletContext().showDocument(new URL("http://java.sun.com/javase/downloads/index.jsp"),"_blank");
					} catch (MalformedURLException e1) {
						SigDebug.error(e1);
					}
				}
			});
/*			jLabel7 = new JLabel();
			jLabel7.setBounds(new java.awt.Rectangle(431,16,13,18));
			jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel7.setHorizontalTextPosition(SwingConstants.LEFT);
			jLabel7.setText("o");
			jLabel7.setFont(new Font("Arial", Font.PLAIN, 12));
			jLabel7.setVisible(false);
*/			
			jLabel7 = new JLabel();
			jLabel7.setBounds(new java.awt.Rectangle(488,16,80,18));
			jLabel7.setHorizontalAlignment(SwingConstants.LEFT);
			jLabel7.setHorizontalTextPosition(SwingConstants.LEFT);
			jLabel7.setText("Google Chrome");
			jLabel7.setForeground(new java.awt.Color(220,0,232));
			jLabel7.setFont(new Font("Dialog", Font.PLAIN, 12));
			jLabel7.setVisible(false);
			jLabel7.addMouseListener(new java.awt.event.MouseAdapter() {   
				public void mouseExited(java.awt.event.MouseEvent e) {    
					jLabel7.setText("<html><body>Google Chrome</body></html>");
					setCursor( new Cursor( Cursor.DEFAULT_CURSOR ) );
				}   
				public void mouseEntered(java.awt.event.MouseEvent e) {    
					jLabel7.setText("<html><body><u>Google Chrome</u></body></html>");
					setCursor( new Cursor( Cursor.HAND_CURSOR ) );
				}
				public void mouseClicked(java.awt.event.MouseEvent e) {
					try {
						getAppletContext().showDocument(new URL("http://www.google.com/chrome/browser/"),"_blank");
					} catch (MalformedURLException e1) {
						SigDebug.error(e1);
					}
				}
			});
			jLabel6 = new JLabel();
			jLabel6.setBounds(new java.awt.Rectangle(444,16,44,18));
			jLabel6.setHorizontalAlignment(SwingConstants.LEFT);
			jLabel6.setHorizontalTextPosition(SwingConstants.LEFT);
			jLabel6.setText("Firefox");
			jLabel6.setForeground(new java.awt.Color(220,0,232));
			jLabel6.setFont(new Font("Dialog", Font.PLAIN, 12));
			jLabel6.setVisible(false);
			jLabel6.addMouseListener(new java.awt.event.MouseAdapter() {   
				public void mouseExited(java.awt.event.MouseEvent e) {    
					jLabel6.setText("<html><body>Firefox</body></html>");
					setCursor( new Cursor( Cursor.DEFAULT_CURSOR ) );
				}   
				public void mouseEntered(java.awt.event.MouseEvent e) {    
					jLabel6.setText("<html><body><u>Firefox</u></body></html>");
					setCursor( new Cursor( Cursor.HAND_CURSOR ) );
				}
				public void mouseClicked(java.awt.event.MouseEvent e) {
					try {
						getAppletContext().showDocument(new URL("http://www.mozilla.org/products/firefox/"),"_blank");
					} catch (MalformedURLException e1) {
						SigDebug.error(e1);
					}
				}
			});
			jLabel5 = new JLabel();
			jLabel5.setBounds(new java.awt.Rectangle(336,16,90,18));
			jLabel5.setHorizontalAlignment(SwingConstants.LEFT);
			jLabel5.setHorizontalTextPosition(SwingConstants.LEFT);
			jLabel5.setText("Internet Explorer");
			jLabel5.setForeground(new java.awt.Color(220,0,232));
			jLabel5.setFont(new Font("Dialog", Font.PLAIN, 12));
			jLabel5.setVisible(false);
			jLabel5.addMouseListener(new java.awt.event.MouseAdapter() {   
				public void mouseExited(java.awt.event.MouseEvent e) {    
					jLabel5.setText("<html><body>Internet Explorer</body></html>");
					setCursor( new Cursor( Cursor.DEFAULT_CURSOR ) );
				}   
				public void mouseEntered(java.awt.event.MouseEvent e) {    
					jLabel5.setText("<html><body><u>Internet Explorer</u></body></html>");
					setCursor( new Cursor( Cursor.HAND_CURSOR ) );
				}   
				public void mouseClicked(java.awt.event.MouseEvent e) {
					try {
						getAppletContext().showDocument(new URL("http://www.microsoft.com/windows/ie/downloads/default.mspx#ENC"),"_blank");
					} catch (MalformedURLException e1) {
						SigDebug.error(e1);
					}
				}
			});
			jLabel3 = new JLabel();
			jLabel3.setBounds(new java.awt.Rectangle(2,100,320,17));
			jLabel3.setHorizontalTextPosition(SwingConstants.RIGHT);
			jLabel3.setText(res.getString("bien"));
			jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabel3.setForeground(new java.awt.Color(14,193,55));
			jLabel3.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel3.setVisible(false);
			jBrowser = new JLabel();
			jBrowser.setBounds(new java.awt.Rectangle(126,16,406,18));
			jBrowser.setHorizontalAlignment(SwingConstants.LEFT);
			jBrowser.setHorizontalTextPosition(SwingConstants.LEFT);
			jBrowser.setText("Navegador no certificado se recomienda");
			jBrowser.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			jBrowser.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseClicked(java.awt.event.MouseEvent e) {
					try {
						getAppletContext().showDocument(new URL("http://www.mozilla.org/products/firefox/"),"_blank");
					} catch (MalformedURLException e1) {
						SigDebug.error(e1);
					}
				}
			});
			jLabel2 = new JLabel();
			jLabel2.setBounds(new java.awt.Rectangle(2,17,94,17));
			jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			jLabel2.setText(res.getString("navegador")+" :");
			jLabel2.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLibreria = new JLabel();
			jLibreria.setBounds(new java.awt.Rectangle(126,58,304,40));
			jLibreria.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLibreria.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			jLibreria.setText("...");
			jLibreria.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			jMaquina = new JLabel();
			jMaquina.setBounds(new java.awt.Rectangle(126,37,204,18));
			jMaquina.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			jMaquina.setText("");
			jMaquina.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			jMaquina.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(2,58,117,17));
			jLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabel.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel.setText(res.getString("lib")+" :");
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(2,37,94,17));
			jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
			jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabel1.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel1.setText(res.getString("mv")+" :");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBackground(java.awt.Color.white);
			jContentPane.setVisible(true);
			jContentPane.add(jLabel1, null);
			jContentPane.add(jLabel, null);
			jContentPane.add(jMaquina, null);
			jContentPane.add(jLibreria, null);
			jContentPane.add(jLabel2, null);
			jContentPane.add(jBrowser, null);
			jContentPane.add(jLabel3, null);
			jContentPane.add(jLabel5, null);
			jContentPane.add(jLabel6, null);
			jContentPane.add(jLabel7, null);
			jContentPane.add(jMaquinaDesc, null);
			jContentPane.add(jLibDesc, null);
		}
		return jContentPane;
	}

	private void getBrowser(String ua){
		browser = "Navegador desconocido";
		browserBuild="";
		int place = 0;
		if ( (ua.indexOf("msie")+1) > 0 || (ua.indexOf("Trident")+1) > 0 ) 
		{
			   browser = "Internet Explorer";
			   if ( (ua.indexOf("msie")+1) > 0 ) {
				//Internet explorer fins 10
			   place = ua.indexOf("msie")+1;
			   place = place+4;
			   String ver = ua.substring(place ,place+3);
			   browserVer = new Float(ver).floatValue();   
			} else {
				//A partir de IE 11 l'user agent ja no duu "msie"
				//Exemple de user agent de  IE 11: Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko
				   place = ua.indexOf("rv:")+1;
				   place = place+4;
				   String ver = ua.substring(place ,place+4);
				   browserVer = new Float(ver).floatValue();
			}
		} else
		{
			if ((ua.indexOf("firefox")+1) > 0) 
			 {
			  browser = "Firefox";
			  place = ua.indexOf("firefox")+1;
			  place = place+7;
			  String ver = ua.substring(place ,place+3);
			  browserVer = new Float(ver).floatValue();
			 } else{
				 if ((ua.indexOf("chrome")+1) > 0) 
				 {
				  browser = "Google chrome";
				  place = ua.indexOf("chrome")+1;
				  place = place+6;
				  String ver = ua.substring(place ,place+3);
				  browserVer = new Float(ver).floatValue();
				 } else{
					 browser = "Navegador no certificado";
				 }
			 }
		}	
		getOSBuild(ua);
	}
	
	private void getOSBuild(String ua){

		if (ua.indexOf("windows nt")>0) {
			if (ua.indexOf("win64")>0) {
				//Internet explorer de 64 bits
				browserBuild+=" (64 bits) ";
			} else {
			   browserBuild+=" (32 bits) ";
			}
			if (ua.indexOf("wow64")>0 || ua.indexOf("x64")>0) {
				browserBuild+=" Windows 64 bits";  
			} else if (ua.indexOf("arm")==-1) {
				//Internet explorer de 32 bits
				browserBuild+=" Windows 32 bits";
			}
		} else if (ua.indexOf("linux")>0) {
			if (ua.indexOf("linux i686")>0) {
				//Linux x86
				browserBuild+=" Linux 32 bits";
			} else if (ua.indexOf("linux x86_64")>0) {
				//Linux x86
				browserBuild+=" Linux 64 bits";
			}
		} else if (ua.indexOf("macintosh")>0) {
			browserBuild+=" Macintosh.";
		}

	}

	private boolean checkVersion(String actVersion,Integer version){
		String ver = null;
		if (actVersion.length()>=5){
			ver = actVersion.substring(0 ,1)+actVersion.substring(2 ,3)+actVersion.substring(4 ,5);
		}
		else{
			ver = actVersion.substring(0 ,1)+actVersion.substring(2 ,3)+"0";
		}
		Integer ver1 = new Integer(ver);
		System.out.println(" version="+version+" ver1="+ver1);
		if (version.intValue() > ver1.intValue()){
			jvmActualitzada = false;
			System.out.println(" jvmActualizada="+jvmActualitzada);
			return (false);
		}else{
			jvmActualitzada = true;
			System.out.println(" jvmActualizada="+jvmActualitzada);
			return(true);
		}
	}
	
	private void check(){
		ua = this.getParameter("ua");
		String version = System.getProperty("java.version");
		String javaArch = System.getProperty("sun.arch.data.model");
		if (javaArch==null) {
			javaArch=" ";
		} else {
			javaArch=" ("+javaArch+" bits) ";
		}
	    if (checkVersion(version,new Integer(142))){
	    	jMaquinaDesc.setVisible(false);
	    	this.jMaquina.setText(System.getProperty("java.version")+javaArch+"("+res.getString("actualizado")+")");
	    }else{
	    	jMaquinaDesc.setVisible(true);
	    	this.jMaquina.setText(System.getProperty("java.version")+javaArch+"("+res.getString("noact")+")");
	    }
	    getBrowser(ua);
	    if (browser!="Navegador no certificado"){
	    	jBrowser.setText(browser+" "+browserVer+" "+browserBuild);
	    	jLabel5.setVisible(false);
	    	jLabel6.setVisible(false);
	    	jLabel7.setVisible(false);
	    }else{
	    	jBrowser.setText("<html><body>"+res.getString("nocert"));
	    	jLabel5.setVisible(true);
	    	jLabel6.setVisible(true);
	    	jLabel7.setVisible(true);
	    }
	    
	    Class c = null;
		try {
			Signer s = new SignerFactory ().getSigner();
			jLibreria.setText(s.getAPIVersion()+" ("+res.getString("actualizados")+")");
			jLibDesc.setVisible(false);
			lt = true;
		} catch (UpgradeNeededException e) {
			String upgradeNeeded = ""+e.getCause();
			String textMostrar = "";
			String textMostrarSplit = "";
			System.out.println("UpgradeNeeded cause:"+upgradeNeeded);
			System.out.println("UpgradeNeeded message: -"+e.getMessage()+"-");
			if (upgradeNeeded.contains("actualizarse") ) {
				textMostrar=upgradeNeeded.substring(upgradeNeeded.indexOf(":")+1);
			} else if (upgradeNeeded.contains("Sistema de firma no instalado") ) {
				textMostrar=upgradeNeeded;
			}
			if (textMostrar.length()>50) {
				textMostrarSplit="<html><body>"+textMostrar.substring(0, 50)+"</br>";
				textMostrarSplit+=textMostrar.substring(50)+"</body></html>";
			} else {
				textMostrarSplit=textMostrar;
			}
			jLibreria.setText(textMostrarSplit);
			//System.out.println("UpgradeNeeded ")+" ("+res.getString("noact")+")");
			installURL = e.getUrl().toString();
			System.out.println("installURL="+installURL);
			jLibDesc.setVisible(true);
		} 
		if ((jvmActualitzada) && (lt)){
			jLabel3.setForeground(new java.awt.Color(14,193,55));
			jLabel3.setText(res.getString("bien"));
			jLabel3.setVisible(true);
		} else{
			jLabel3.setForeground(java.awt.Color.red);
			jLabel3.setText(res.getString("red"));
			jLabel3.setVisible(true);
		}
	}

	public void start() {
		super.start();
		this.check();
	}
}

